/* 
 *
 * 2004  Met_Enkeph aka Evan Eveland, DC
 * First attempt at a firefox extension
 * create desktop shortcut a la IE
 *
 * To do:
 *    variably call findWinDeskloc, findLinDeskloc or findMacDeskloc
 *    linux version (Gnome vs KDE ... aaarrrrrgggggg... )
 *    mac(?) version
 *
 */

var deskcutMenuItems = new Array("deskcut-do-view", "deskcut-do-viewlink");
var gOS;
// gOS will be a string of: win, mac, lin
var gOk2AlertUser;
var gSetPath;
var gDeskCutDir;

var gDeskcutViewBundle;

// ---------------------------------------------- deskcutContext() ----------------------------------------------
function deskcutContext() {
  if(gContextMenu) {
    for(var i=0; i<deskcutMenuItems.length; i++) {
      var menuitem = document.getElementById(deskcutMenuItems[i]);
      if(menuitem && (i == 0))
        menuitem.hidden = (gContextMenu.isTextSelected || gContextMenu.onLink || gContextMenu.onImage || gContextMenu.onTextInput );
      else if (menuitem) {
        menuitem.hidden = ! gContextMenu.onLink;
      }
    }
  }
}

// ---------------------------------------------- deskCut() ----------------------------------------------
function deskCut() {
  if(gContextMenu) {
    var name = gBrowser.contentDocument.title;
    var href = gBrowser.currentURI.spec;
    //alert(gOS);
    switch (gOS) {
      case 'win':{
        gDeskCutDir = checkDeskCutDir();
        //alert (gDeskCutDir);
        if (gDeskCutDir != null && gDeskCutDir != "") {
          var str = gDeskCutDir;
        } else {
          var str = findWinDeskloc();
        }
        break
      }
      case 'mac':{break }
      case 'lin':{
        gDeskCutDir = checkDeskCutDir();
        //alert (gDeskCutDir);
        if (gDeskCutDir != null && gDeskCutDir != "") {
          var str = gDeskCutDir;
        } else {
          var str = findLinDeskloc();
        } 
        break 
      }
    }
    if (href == "" || str == "") {
      alert("href: "+href+"\n deskloc: "+str);
      return;
    }
    else {
      createShortcut(href,str, name);
    }
    var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    var prefs = prefservice.getBranch("");
    var alert1 = "Shortcut to";
    var alert2 = "created.";
    try {
        alert1 = gDeskcutViewBundle.getString("overlay-alert1");
        alert2 = gDeskcutViewBundle.getString("overlay-alert2");
    }
    catch(e) {
        alert(e);
    }
    if (prefs.getPrefType("deskcut.alertUser") == prefs.PREF_BOOL) {
      try {
        gOk2AlertUser = prefs.getBoolPref("deskcut.alertUser");
      } catch (ex) {
      }
    }
    if (gOk2AlertUser) {
      alert(alert1 + " " + href + " " + alert2);
    }
    prefs=null;
  }
}

// ---------------------------------------------- deskCutLink() ----------------------------------------------
function deskCutLink() {
  if(gContextMenu) {
    var href = gContextMenu.linkURL();
    var name = gContextMenu.linkText();
    switch (gOS) {
      //case 'win':{ var str = findWinDeskloc(); break }
      case 'win':{
        gDeskCutDir = checkDeskCutDir();
        if (gDeskCutDir != null && gDeskCutDir != "") {
          var str = gDeskCutDir;
        } else {
          var str = findWinDeskloc();
        }
        break
      }
      case 'mac':{break }
      case 'lin':{
        gDeskCutDir = checkDeskCutDir();
        if (gDeskCutDir != null && gDeskCutDir != "") {
          var str = gDeskCutDir;
        } else {
          var str = findLinDeskloc();
        }
        break 
      }
    }
    if (href == "" || str == "") {
      alert("href: "+href+"\n deskloc: "+str);
      return;
    }
    else { 
      createShortcut(href,str, name);
    }
    var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    var prefs = prefservice.getBranch("");
    var alert1 = "Shortcut to";
    var alert2 = "created.";
    try {
        alert1 = gDeskcutViewBundle.getString("overlay-alert1");
        alert2 = gDeskcutViewBundle.getString("overlay-alert2");
    }
    catch(e) {
        alert(e);
    }
    if (prefs.getPrefType("deskcut.alertUser") == prefs.PREF_BOOL) {
      try {
        gOk2AlertUser = prefs.getBoolPref("deskcut.alertUser");
      }
      catch (ex) {
      }
    }
    if (gOk2AlertUser) {
      alert(alert1 + " " + href + " " + alert2);
    }
    prefs=null;
  }
}


// ---------------------------------------------- deskcutInit() ----------------------------------------------
function deskcutInit() {
  //do os detect and set global variable
  var menu = document.getElementById("contentAreaContextMenu");
  menu.addEventListener("popupshowing",deskcutContext,false);
  var gOk2AlertUser = false;
  gDeskcutViewBundle = document.getElementById("bundle_deskcut");
  if (! gDeskcutViewBundle) {
    alert("no bundle");
  }
  if (typeof(window.navigator.platform) != 'undefined') {
    platform = window.navigator.platform.toLowerCase();
    if (platform.indexOf('win') != -1)
      gOS = 'win';
    else if (platform.indexOf('mac') != -1)
      gOS = 'mac';
    else if (platform.indexOf('linux') != -1)
      gOS = 'lin';
  }
}

// ---------------------------------------------- setDeskcutOptions() ----------------------------------------------
function setDeskcutOptions() {
  var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var prefs = prefService.getBranch("");
  // --------------- alertuser ---------------
  var result = document.getElementById('alertUser').checked;
  prefs.setBoolPref("deskcut.alertUser", result);
  gOk2AlertUser = result
  // --------------- setPath ---------------
  result = document.getElementById('setPath').checked;
  prefs.setBoolPref("deskcut.setPath", result);
  gSetPath = result;
  // --------------- deskCutDir ---------------
  result = document.getElementById('deskCutDir').value;
  prefs.setCharPref("deskcut.deskCutDir", result)
  if (gSetPath != false) {
    gDeskCutDir = result;
  }
  prefs=null;
  window.close();
}

// ---------------------------------------------- checkDeskCutDir() ----------------------------------------------
// check if deskcut.setPath id true; if so return deskcut.deskCutDir; else return ""
function checkDeskCutDir() {
  var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var prefs = prefservice.getBranch("");
  // -------------------- deskcut.pathPromp --------------------
  if (prefs.getPrefType("deskcut.setPath") == prefs.PREF_BOOL) {
    try {
      gSetPath = prefs.getBoolPref("deskcut.setPath");
    } catch (ex) {
    }
  }
  if (gSetPath) {
    // -------------------- deskcut.deskCutDir --------------------
    if (prefs.getPrefType("deskcut.deskCutDir") == prefs.PREF_STRING) {
      try {
        var tmpDir = prefs.getCharPref("deskcut.deskCutDir");
      } catch (ex) {
      }
    }
    if (tmpDir != null) {
      return tmpDir;
    }
  }
  prefs = null;
  return "";
}

// ---------------------------------------------- initPrefs() ----------------------------------------------
function initPrefs() {
  var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var prefs = prefservice.getBranch("");
  var gOk2AlertUser = null;
  var gSetPath = null;
  var gDeskCutDir = null;
  // -------------------- deskcut.alertUser --------------------
  if (prefs.getPrefType("deskcut.alertUser") == prefs.PREF_BOOL) {
    try {
      gOk2AlertUser = prefs.getBoolPref("deskcut.alertUser");
    } catch (ex) {
    }
  }
  if (gOk2AlertUser != null) {
        document.getElementById('alertUser').checked = gOk2AlertUser;
  }
  // -------------------- deskcut.setPath --------------------
  if (prefs.getPrefType("deskcut.setPath") == prefs.PREF_BOOL) {
    try {
      gSetPath = prefs.getBoolPref("deskcut.setPath");
    } catch (ex) {
    }
  }
  if (gSetPath != null) {
        document.getElementById('setPath').checked = gSetPath;
        setTextBoxOpts()
  }
  // -------------------- deskcut.deskCutDir --------------------
  if (prefs.getPrefType("deskcut.deskCutDir") == prefs.PREF_STRING) {
    try {
      gDeskCutDir = prefs.getCharPref("deskcut.deskCutDir");
    } catch (ex) {
    }
  }
  if (gDeskCutDir != null) {
    document.getElementById("deskCutDir").value = gDeskCutDir;
  }
  // OK; if
  if (gSetPath == false) {
    gDeskCutDir = "";
  }
  prefs = null;
}

// ---------------------------------------------- findWinDeskloc() ----------------------------------------------
function findWinDeskloc() {
  // replace nasty registry code above with a call to directory_service get method...
  // from /xpcom/io/nsDirectoryServiceDefs.h
  // XP_WIN uses: 'DeskV' or 'DeskP'
  var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
  var winDesktop = dirService.get('DeskV', Components.interfaces.nsILocalFile);
  if (winDesktop.exists()) {
    return winDesktop.path;
  } else  {

    winDesktop = dirService.get('Favs', Components.interfaces.nsILocalFile);
    if (winDesktop.exists()) {
      return winDesktop.path;
    }
  }
}

// ---------------------------------------------- findLinDeskloc() ----------------------------------------------
function findLinDeskloc() {
  var KDE_installed = false;
  var GNOME_installed = false;
  // XP_UNIX uses: 'Home'
  // need to check for .KDE or GNOME and drop a desktop entity in it...
  //               http://webcvs.kde.org/cgi-bin/cvsweb.cgi/~checkout~/kdelibs/kio/DESKTOP_ENTRY_STANDARD
  //               http://www.freedesktop.org/standards/desktop-entry-spec/desktop-entry-spec-0.9.4.html
  // check for ~/.Desktop (KDE) or ~/.gnome-desktop (err... GNOME)
  // if only one write it there
  // if both, check for default (assign a user-option if we're linux... []KDE []Gnome []Other ...) and prompt if needed
  // if neither, prompt for save location
  var dirService = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
  var linHome = dirService.get('Home', Components.interfaces.nsILocalFile);
  if (linHome.exists()) {
    //alert('In findLinDesktop '+linHome.path);
    // Check KDE
    //**************************************************************************************
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var filePath = linHome.path + "//Desktop//";
    file.initWithPath (filePath);
    if (file.exists()) {
      KDE_installed = true;
    }
    //**************************************************************************************
    // Check Gnome
    filePath = linHome.path + "//.gnome-desktop//";
    file.initWithPath (filePath);
    if (file.exists()) {
      GNOME_installed = true;
    }
    // **************** OK we've looked for both so ************
    if (KDE_installed == true) {
      if (GNOME_installed == true) {
        return promptForPath();
      } else {
        return (linHome.path + "//Desktop//");
      }
    } else {
      if (GNOME_installed == false) {
        return promptForPath();
      } else {
        return (linHome.path + "//Desktop//");
      }
    }
  } else {
    return promptForPath();
  }

}

// ---------------------------------------------- promptForPath) ----------------------------------------------
function promptForPath() {
  // we couldn't find it or 'prompt for path' pref is set, so ask for the desktop location...
  // return "" if not found...
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
	const nsILocalFile = Components.interfaces.nsILocalFile;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Save deskCuts to:", nsIFilePicker.modeGetFolder);

	fp.appendFilters(nsIFilePicker.filterAll);
	var ret = fp.show();
	if (ret == nsIFilePicker.returnOK) {
		var localFile = fp.file.QueryInterface(nsILocalFile);
		var daPath = fp.file.path;
    return daPath;
	}
		else if (ret == nsIFilePicker.returnCancel) {
      return ""
	}
}

// ---------------------------------------------- fillTextBox() ----------------------------------------------
// same as above, but fill filePicker with result
function fillTextBox() {
  // we couldn't find it or prompt for path pref is set, so ask for the desktop location...
  // return "" if not found...
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
	const nsILocalFile = Components.interfaces.nsILocalFile;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, "Save deskCuts to:", nsIFilePicker.modeGetFolder);

	fp.appendFilters(nsIFilePicker.filterAll);
	var ret = fp.show();
	//var textBoxText = document.getElementById("deskCutDir");
	if (ret == nsIFilePicker.returnOK) {
		var localFile = fp.file.QueryInterface(nsILocalFile);
		var daPath = fp.file.path;
		//textBoxText.value = daPath;
		document.getElementById('deskCutDir').value = daPath;
	}
		else if (ret == nsIFilePicker.returnCancel) {
	}
}

// ---------------------------------------------- setTextBoxOpts() ----------------------------------------------
function setTextBoxOpts() {
  //alert("in setTextBoxOpts");
  var result = document.getElementById('setPath').checked;
  if (result == true) {
    document.getElementById('deskCutDir').disabled = false;
    document.getElementById('daFilePicker').disabled = false;
  } else {
    document.getElementById('deskCutDir').disabled = true;
    document.getElementById('daFilePicker').disabled = true;
  }
  
}
// ---------------------------------------------- createShortcut(url,path,name) ----------------------------------------------
function createShortcut(url,path,name) {
  // url is string to url, path is path to desktop , name is the name to give the shortcut
  //  Craft our url in the form:
  //  Win:
  //   [DEFAULT]\nBASEURL=http://<<some friggin URL here>>\n[InternetShortcut]\nURL=http://<<some friggin URL here>>\n
  //  Linux:
  //   [Desktop Entry]\nEncoding=UTF-8\nType=Link\nName=<<some name here>>\nURL=http://<<some friggin URL here>>\n
  // will work for Gnome or KDE...
  //alert('In createShortcut with:\nUrl: '+url+'\nPath: '+path+'\nName: '+name); 
  try {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var filePath = path + "\\" + stripBad(name);
    switch (gOS) {
        case 'win':{
	  var filePath = path + "\\" + stripBad(name);
	  filePath += ".url"; 
	  break 
	}
        case 'mac':{break }
        case 'lin':{
	  var filePath = path + "//" + stripBad(name);
	  filePath += ".desktop"; 
	  break 
	}
    }
    file.initWithPath (filePath);
    if (!file.exists()) {
      file.create(0x00, 0644);
		  }
    var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    outputStream.init(file, 0x20 | 0x02, 00004,null);
    switch (gOS) {
        case 'win':{ var output = "[DEFAULT]\nBASEURL=" + url + "\n[InternetShortcut]\nURL=" + url + "\n"; break }
        case 'mac':{break }
        case 'lin':{ var output = "[Desktop Entry]\nEncoding=UTF-8\nType=Link\nName=" + stripBad(name) + "\nURL=" + url + "\n"; break }
    }
    var result = outputStream.write( output, output.length );
    outputStream.flush();
    outputStream.close();
    return true;
  }
  catch (ex) {
    alert('Bad things happened: '+ex);
    return false;
  }
}

// ---------------------------------------------- stripBad(filename) ----------------------------------------------
function stripBad(filename) {
  // OK; need to yank anything that will kill our happy shortcut filename
  filename = filename.replace(/[\\\/\:\*\?\"\<\>\|]/g, '');
  filename = filename.replace(/(^[\s]+)|([\s]+$)/g, '');
  return filename;
}


// do the init on load
window.addEventListener("load", deskcutInit, false);


/*
// --------------------------------------------------------------------------------------------------------------
// Assorted depricated/just bad crap here....
// --------------------------------------------------------------------------------------------------------------
// findWinDeskloc(), the registry version
function findWinDeskloc() {
  //search out the users desktop in the mighty Windows registry...
  // registry constants values:
	// 0: HKEY_CLASSES_ROOT
	// 1: HKEY_CURRENT_CONFIG
	// 2: HKEY_CURRENT_USER
	// 3: HKEY_LOCAL_MACHINE
	// 4: HKEY_USERS
  var winhooks = Components.classes["@mozilla.org/winhooks;1"].getService(Components.interfaces.nsIWindowsRegistry);
  // check current_user first
  var reg = winhooks.getRegistryEntry("2","SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders","Desktop");
  if(reg != "") {
    return (reg);
  }
  else
  {
    //check Common desktop
    var reg2 = winhooks.getRegistryEntry("3","SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders","Common Desktop");
    if(reg2 != "") {
      return (reg2);
    }
  }
  //OK; I give up
  return("");
}

// createWinShortcut(url,path,name)
function createWinShortcut(url,path,name) {
  // url is string to url, path is path to windows desktop , name is the name to give the shortcut
  //  Craft our url in the form:
  //  [DEFAULT]\nBASEURL=http://<<some friggin URL here>>\n[InternetShortcut]\nURL=http://<<some friggin URL here>>\n
  //alert(url+"\n"+path+"\n"+name+"\n")
  try {
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    var filePath = path + "\\" + stripBad(name) + ".url";
    file.initWithPath (filePath);
    if (!file.exists()) {
      file.create(0x00, 0644);
		  }
    var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    outputStream.init(file, 0x20 | 0x02, 00004,null);
    var output = "[DEFAULT]\nBASEURL=" + url + "\n[InternetShortcut]\nURL=" + url + "\n";
    var result = outputStream.write( output, output.length );
    outputStream.flush();
    outputStream.close();
    return true;
  }
  catch (ex) {
    alert('Bad things happened: '+ex);
    return false;
  }
}
*/
